-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 14-Desember-2014
-- Description:	Insert Data to TB_T_DVL_FI_TRANS_H (INV)
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_TEMP_TRANS_H_INV]
	@PROCESS_ID BIGINT
AS

DECLARE
	@DOC_NO VARCHAR(15),
	@DOC_YEAR VARCHAR(4),
	@INV_NO VARCHAR(20),
	@UPDATE_DT VARCHAR(10),
	@UPDATE_BY VARCHAR(10),
	@REFF_NO VARCHAR(20),
	@DOC_DT VARCHAR(30),
	@DOC_HEADER_TXT VARCHAR(20),
	@LP_CD VARCHAR(20),
	@PAYMENT_TERM_CD VARCHAR(4),
	@PAYMENT_METHOD_CD VARCHAR(4),
	@PARTNER_BANK_KEY VARCHAR(10),
	@BILLING_STS VARCHAR(1),
	@DOC_NO_OLD VARCHAR(15),
	@COUNTER INT
BEGIN
	--Get DOC Year
	SET @DOC_YEAR = CONVERT(VARCHAR, YEAR(GETDATE()))
	
	--Get Reff No
	SELECT @REFF_NO = MAX(INV_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID

	--Get Payment Term Cd
	SELECT @PAYMENT_TERM_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_PAYMENT_TERM_LIV'

	--Get Payment Method Cd
	SELECT @PAYMENT_METHOD_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_PAYMENT_METHOD_LIV'

	--Get Partner Bank Key
	SELECT @PARTNER_BANK_KEY = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_PARTNER_BANK_KEY'

	--Get Doc No in TB_R
	SELECT @DOC_NO_OLD = MAX(DOC_NO) FROM TB_R_DLV_FI_TRANS_H WHERE SUBSTRING(DOC_NO, 1, 3) = 'TWX'
 	SET @DOC_NO_OLD = ISNULL(@DOC_NO_OLD, '0')
	IF(@DOC_NO_OLD <> '0')
	BEGIN
		SET @DOC_NO_OLD = SUBSTRING(@DOC_NO_OLD, 4, 12)
	END

	SET @COUNTER = 1
	DECLARE TransH_Cursor CURSOR FOR
		SELECT DISTINCT INV_NO, BILLING_STS FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND (BILLING_STS = '3' OR BILLING_STS = '4')
		OPEN TransH_Cursor

		FETCH NEXT FROM TransH_Cursor INTO @INV_NO, @BILLING_STS
		WHILE(@@FETCH_STATUS = 0)
		BEGIN
			--Get Update Dt
			SELECT TOP 1 @UPDATE_DT = UPDATE_DT FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 

			--Get Update By
			SELECT TOP 1 @UPDATE_BY = UPDATE_BY FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS

			--Get INV Date
			SELECT @DOC_DT = MAX(CASE WHEN((INV_DT = '') OR (INV_DT = NULL)) THEN GETDATE() ELSE INV_DT END) FROM TB_T_PROTO_INV WHERE INV_NO = @INV_NO AND PROCESS_ID = @PROCESS_ID

			--Get DOC Header TXT
			SELECT @DOC_HEADER_TXT = MAX(TAX_NO) FROM TB_T_PROTO_INV WHERE INV_NO = @INV_NO AND PROCESS_ID = @PROCESS_ID

			--Get LP Code
			SELECT @LP_CD = MAX(SUPPLIER_NO) FROM TB_T_PROTO_INV WHERE INV_NO = @INV_NO AND PROCESS_ID = @PROCESS_ID

			SET @DOC_NO = 'TWX' + RIGHT('000000000000' + CAST((@COUNTER + CONVERT(INT, @DOC_NO_OLD)) AS VARCHAR(12)), 12)
			--SELECT @DOC_DT
			INSERT INTO TB_T_DLV_FI_TRANS_H VALUES (@DOC_NO, @DOC_YEAR, @DOC_DT, GETDATE(), CONVERT(VARCHAR(25), @DOC_HEADER_TXT), 
				CONVERT(VARCHAR(16), @INV_NO), @PAYMENT_TERM_CD, RIGHT('0000' + CAST((SUBSTRING(@LP_CD, 1, 4)) AS VARCHAR(4)), 4), NULL, @PAYMENT_METHOD_CD, @PARTNER_BANK_KEY, 
				NULL, NULL, NULL, CONVERT(VARCHAR(20), @UPDATE_BY), @UPDATE_DT, NULL, NULL, @PROCESS_ID, NULL)
				
			IF(@BILLING_STS = '4')
			BEGIN
				EXEC SP_PROTO_INSERT_TEMP_TRANS_D_INV_4 @PROCESS_ID, @INV_NO, @DOC_NO, @BILLING_STS
				--SET @BILLING_STS = 0
			END
			ELSE IF(@BILLING_STS = '3')
			BEGIN
				--SET @BILLING_STS = 0
				EXEC SP_PROTO_INSERT_TEMP_TRANS_D_INV_3 @PROCESS_ID, @INV_NO, @DOC_NO, @BILLING_STS
			END
			SET @COUNTER = @COUNTER + 1
			FETCH NEXT FROM TransH_Cursor INTO @INV_NO, @BILLING_STS
		END

		CLOSE TransH_Cursor
	DEALLOCATE TransH_Cursor
END

